package dnd.model;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author l-ectron-x
 * @param <T>
 */
public class Module<T extends Part> {
    
    private String name;
    private final List<Part> partList;
    
    public Module() {
        this("Unbenannt");
    }
    
    public Module(String name) {
        partList = new ArrayList<>();
        this.name = name;
    }
    
    public boolean add(Part part) {
        return partList.add(part);
    }
    
    public Part get(int index) {
        return partList.get(index);
    }
    
    public String getModuleName() {
        return name;
    }
    
    public boolean remove(Part part) {
        return partList.remove(part);
    }
    
    public Part set(int index, Part part) {
        return partList.set(index, part);
    }
    
    public int size() {
        return partList.size();
    }
    
    public void createDummyParts() {
        Part p1 = new Part("Y123456", "HD-Schlauch 1,2m");
        p1.setIcon(new Symbol());
        Part p2 = new Part("A234567", "CO2-Sensor");
        p2.setIcon(new Symbol());
        Part p3 = new Part("F876543", "Dichtring");
        p3.setIcon(new Symbol());
        Part p4 = new Part("Z987654", "HUD-Display");
        p4.setIcon(new Symbol());
        Part p5 = new Part("Y345678", "Magnetventil");
        p5.setIcon(new Symbol());
        Part p6 = new Part("P123456", "Kalkpatrone");
        p6.setIcon(new Symbol());
        p6.setAssigned(true);
        Part p7 = new Part("A765432", "O2-Sensor");
        p7.setIcon(new Symbol());
        Part p8 = new Part("B432987", "Atemkalk");
        p8.setIcon(new Symbol());
        Part p9 = new Part("N918273", "Mundstück");
        p9.setIcon(new Symbol());
        partList.add(p1);
        partList.add(p2);
        partList.add(p3);
        partList.add(p4);
        partList.add(p5);
        partList.add(p6);
        partList.add(p7);
        partList.add(p8);
        partList.add(p9);
        
    }
    
}
