package dnd.model;

import java.io.Serializable;

/**
 *
 * @author l-ectron-x
 */
public class Part implements Serializable {

    public static final long serialVersionUID = 1L;

    private String code;
    private String name;
    private Symbol symbol;
    private boolean assigned;

    public Part() {
        this(null);
    }

    public Part(String code) {
        this(code, null);
    }

    public Part(String code, String name) {
        this.code = code;
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public Symbol getIcon() {
        return symbol;
    }

    public String getName() {
        return name;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public void setIcon(Symbol symbol) {
        this.symbol = symbol;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isAssigned() {
        return assigned;
    }

    public void setAssigned(boolean assigned) {
        this.assigned = assigned;
    }

}
