package dnd.model;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.util.Random;
import javax.swing.Icon;

/**
 *
 * @author l-ectron-x
 */
public class Symbol implements Icon {

    private final Random random;
    private final int shape;
    private final Color shapeColor;
    private static final int SIZE = 22;
    private int[] xpoints;
    private int[] ypoints;

    public Symbol() {
        random = new Random();
        shape = random.nextInt(4);
        shapeColor = new Color(getColorInt(), getColorInt(), getColorInt());
    }

    @Override
    public void paintIcon(Component c, Graphics gr, int x, int y) {
        Graphics2D g = (Graphics2D) gr;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g.setColor(shapeColor);
        switch (shape) {
            case 0:
                g.fillRect(x, y, SIZE, SIZE);
                break;
            case 1:
                g.fillOval(x, y, SIZE, SIZE);
                break;
            case 2:
                xpoints = new int[]{x + SIZE / 2, x + SIZE, x};
                ypoints = new int[]{y, SIZE, SIZE};
                int npoints = xpoints.length;
                g.fillPolygon(xpoints, ypoints, npoints);
                break;
            default:
                xpoints = new int[]{x, x + SIZE, x + SIZE / 2};
                ypoints = new int[]{y, y, SIZE};
                npoints = xpoints.length;
                g.fillPolygon(xpoints, ypoints, npoints);

        }
    }

    @Override
    public int getIconWidth() {
        return SIZE;
    }

    @Override
    public int getIconHeight() {
        return SIZE;
    }

    private int getColorInt() {
        return random.nextInt(256);
    }

    // XXX Die Methode macht keinen Sinn :-/
//    private int getRandomInt(int i) {
//        int c;
//        while ((c = random.nextInt(i)) > 0) {
//            return c;
//        }
//        return 0;
//    }

}
